#pragma once

//Oobt@NXev[g

template <class T, class U = unsigned int>
class CRingBuffer
{
public:
	CRingBuffer operator<<(T&);
	CRingBuffer operator>>(T*);
	CRingBuffer operator>>(T**);

	bool AddData(T&);
	T* GetData(void);
	U UsedSize(void);
	U BufferSize(void);

	void Clear(void);

	CRingBuffer(unsigned char sizeWithBitWidth);
	~CRingBuffer();

protected:
	T* buffer;
	U writePtr;
	U readPtr;
	U ptrMask;
};
