// test_dyud.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "test_dyud.h"
#include "IDyud200.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

typedef IBonDriver* (*PCREATEBONDRIVER)(void);

HMODULE hBonDriver;
PCREATEBONDRIVER pCreateBonDriver;
IDY_UD200* dyud200;

HANDLE hFile = NULL;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
INT_PTR CALLBACK	DlgProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: ɃR[h}ĂB
	hBonDriver = LoadLibrary(_T("BonDriver_dyud.dll"));
	pCreateBonDriver = (PCREATEBONDRIVER)GetProcAddress(hBonDriver, "CreateBonDriver");

	dyud200 = dynamic_cast<IDY_UD200*>(pCreateBonDriver());
	dyud200->OpenTuner();

	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);

	dyud200->CloseTuner();
	dyud200->Release();

	return 0;
}


#define SendMessageDlgItem(x, y, z, w) SendMessage(GetDlgItem(hDlg, (x)), (y), (z), (w))
#define AddList(x, y) SendMessageDlgItem((x), CB_ADDSTRING, 0, (LPARAM)(y))

INT_PTR CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	OPENFILENAME ofn;
	TCHAR szFilename[1024];

	LPCTSTR sz;

	TCHAR szStr[256];
	DWORD dw;
LoadLibrary(_T("winscard.dll"));
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		dw=0;
		while((sz=dyud200->EnumTuningSpace(dw++)) != NULL)
			AddList(IDC_SPACE, sz);
		SendMessageDlgItem(IDC_SPACE, CB_SETCURSEL, 0, 0);

		dw=0;
		while((sz=dyud200->EnumChannelName(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0), dw++)) != NULL)
			AddList(IDC_CHANNEL, sz);
		SendMessageDlgItem(IDC_CHANNEL, CB_SETCURSEL, 0, 0);

		SetTimer(hDlg, 0, 100, NULL);

		return (INT_PTR)TRUE;

	case WM_TIMER:
		switch(wParam)
		{
		case 0:
			while(dyud200->GetReadyCount())
			{
				DWORD dwB;
				BYTE *pBuf;
				if(dyud200->GetTsStream(&pBuf, &dw, &dwB))
					WriteFile(hFile, pBuf, dw, &dwB, NULL);
			}
			break;
		}
		return (INT_PTR)TRUE;
	case WM_COMMAND:
		if (LOWORD(wParam) == IDSTART)
		{
			if(hFile)
				return (INT_PTR)TRUE;

			memset(&ofn, 0, sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hDlg;
			ofn.lpstrFilter = _T("MPEG-TS\0*.ts\0");
			ofn.lpstrFile = szFilename;
			ofn.nMaxFile = 1024;
			szFilename[0] = 0;

			if(GetSaveFileName(&ofn))
			{
				hFile = CreateFile(szFilename,GENERIC_WRITE ,0 ,NULL ,CREATE_ALWAYS ,FILE_ATTRIBUTE_NORMAL ,NULL);
				if(hFile)
				{
					_stprintf_s(szStr, _T("^撆: %s %s - %s"),
						dyud200->EnumTuningSpace(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0)),
						dyud200->EnumChannelName(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0),
												SendMessageDlgItem(IDC_CHANNEL, CB_GETCURSEL, 0, 0)),
						_T(APPNAME));
					SetWindowText(hDlg, szStr);

					dyud200->SetChannel(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0),
										SendMessageDlgItem(IDC_CHANNEL, CB_GETCURSEL, 0, 0));

					dyud200->PurgeTsStream();
					SetTimer(hDlg, 0, 1, NULL);
					//Startcap
				}else{
					MessageBox(hDlg, _T("t@C쐬o܂łB"), _T("G["), MB_OK);
				}
			}
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDSTOP)
		{
			SetWindowText(hDlg, _T(APPNAME));
			KillTimer(hDlg, 0);
			if(hFile) CloseHandle(hFile);
			hFile = NULL;
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDCANCEL)
		{
			if(hFile) CloseHandle(hFile);
			hFile = NULL;
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_SPACE)
		{
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				while(SendMessageDlgItem(IDC_CHANNEL, CB_GETCOUNT, 0, 0) != 0)
				{
					SendMessageDlgItem(IDC_CHANNEL, CB_DELETESTRING, 0, 0);
				}

				dw=0;
				while((sz=dyud200->EnumChannelName(SendMessageDlgItem(IDC_SPACE, CB_GETCURSEL, 0, 0), dw++)) != NULL)
					AddList(IDC_CHANNEL, sz);
				SendMessageDlgItem(IDC_CHANNEL, CB_SETCURSEL, 0, 0);
			}

		}
		break;
	}
	return (INT_PTR)FALSE;
}
